package tennisformulas; # sumo you get pushed out of the ring modern judo there is the concept of a points system you get enough points you win there is a similar evil herein the evil of the mathematics actually just take one off all the bible chapter and verse numerals to make them start at zero or nil or love okay

use strict;
use warnings;
require Exporter;
our @ISA = qw(Exporter);
our @EXPORT_OK = qw(formulas gamep);

sub formulas {
  my $self = shift;
  my $base = $self->{basep}/100;
  generatep($self->{decider}, $self->{finalsettiebreakflag}, $base + $self->{difference}, $base);
#  generatep($self->{decider}, $self->{finalsettiebreakflag}, $base + $self->{difference}/2, $base - $self->{difference}/2);
}

sub generatep {
  my ($decider, $fstb, $p1, $p2) = @_;
  my $tb = tbformula($p1, $p2, notiebreakP($p1, $p2));
  my $g1 = gameformula($p1, deuceP($p1));
  my $g2 = gameformula($p2, deuceP($p2));
  my $tbsf = setformula($g1, $g2, $tb);
  my $ntbsf = $fstb ? undef : setformula($g1, $g2, notiebreakP($g1, $g2));
  my $m = matchformula($decider, $tbsf, $fstb ? $tbsf : $ntbsf);
  return [$tb, $tbsf, $ntbsf, $m];
}

sub gamep {
  my $p = shift;
  gameformula($p, deuceP($p));
}

sub tbformula {
  my ($x, $y, $z) = @_;
  my $x4y4 = $x**4*$y**4;
  littletb2($x)*(1 - $z) + $x*$y*(-43 + 258*$x - 645*$x**2 + 860*$x**3 - 645*$x**4 + 258*$x**5 - 43*$x**6 + 111*$y - 155*$y**2 + 125*$y**3 - 57*$y**4 + 13*$y**5 - $y**6) + $x**2*$y**2*(-1017 + 3420*$x - 5730*$x**2 + 5175*$x**3 - 2421*$x**4 + 462*$x**5 + 1950*$y - 8350*$x*$y + 17000*$x**2*$y - 18075*$x**3*$y + 9730*$x**4*$y - 2100*$x**5*$y - 2055*$y**2+ 10875*$x*$y**2 + 1206*$y**3 - 7785*$x*$y**3 - 363*$y**4 + 2870*$x*$y**4 + 42*$y**5 - 420*$x*$y**5) + $x4y4*(-26375 + 32550*$x - 19950*$x**2 + 4830*$x**3 + 22260*$y - 31626*$x*$y + 21924*$x**2*$y - 5922*$x**3*$y - 9660*$y**2 + 15750*$x*$y**2 - 12306*$x**2*$y**2 + 3696*$x**3*$y**2 + 1680*$y**3 - 3150*$x*$y**3 + 2772*$x**2*$y**3 - 924*$x**3*$y**3) + $z*(1 - littletb2($y) + 86*$x*$y + 2034*$x**2*$y**2 + 16700*$x**3*$y**3 + littletb($x, $y, $x4y4) + littletb($y, $x, $x4y4) + $x4y4*(52750 + 63252*$x*$y + 24612*$x**2*$y**2 + 1848*$x**3*$y**3));
}

sub littletb2 {
  my $x = shift;
  7*$x - 21*$x**2 + 35*$x**3 - 35*$x**4 + 21*$x**5 - 7*$x**6 + $x**7;
}

sub littletb {
  my ($x, $y, $x4y4) = @_;
  -369*$x*$y**2 + 44*$x**7*$y + 702*$x**5*$y - 271*$x**6*$y - 504*$x**2*$y**7 + 800*$x**3*$y + 2784*$x**2*$y**6 - 6381*$x**5*$y**2 - 5370*$x**2*$y**3 + 25860*$x**3*$y**5 - 12600*$x**3*$y**6 + 2520*$x**3*$y**7 - 985*$x*$y**4 + 7785*$x**4*$y**2 - 27875*$x**3*$y**4 + $x4y4*(-54810*$x + 29610*$x**2 - 37674*$x**2*$y - 6510*$x**3 + 9072*$x**3*$y - 6468*$x**3*$y**2);
}

sub setformula {
  my ($x, $y, $z) = @_;
  my $x2y2 = $x**2*$y**2;
  littlesf2($x)*(1 - $z) - 31*$x*$y + 155*$x**2*$y - 310*$x**3*$y + 310*$x**4*$y - 155*$x**5*$y + 31*$x**6*$y + 65*$x*$y**2 + $x2y2*(-500 + 1350*$x - 1700*$x**2 + 1025*$x**3 - 240*$x**4 + 750*$y - 2600*$x*$y + 4000*$x**2*$y - 2850*$x**3*$y + 770*$x**4*$y - 575*$y**2 + 2500*$x*$y**2 + $x2y2*(-4625 + 3850*$x - 1190*$x**2 + 2590*$y - 2506*$x*$y + 882*$x**2*$y - 560*$y**2 + 630*$x*$y**2 - 252*$x**2*$y**2) + 215*$y**3 - 1170*$x*$y**3 - 30*$y**4 + 210*$x*$y**4) - 70*$x*$y**3 + 40*$x*$y**4 - 11*$x*$y**5  + $x*$y**6 + $z*(1 - littlesf2($y) + 62*$x*$y + littlesf($x, $y, $x2y2) + littlesf($y, $x, $x2y2) + $x2y2*(1000 + 5200*$x*$y + $x2y2*(9250 + 5012*$x*$y + 504*$x2y2)));
}

sub littlesf2 {
  my $x = shift;
  6*$x - 15*$x**2 + 20*$x**3 - 15*$x**4 + 6*$x**5 - $x**6;
}

sub littlesf {
  my ($w, $v, $x2y2) = @_;
  -220*$w**2*$v + 380*$w**3*$v - 350*$w**4*$v  + 166*$w**5*$v - 32*$w**6*$v + $x2y2*(-2100*$w +2275*$w**2 - 1240*$w**3 + 270*$w**4 - 6500*$w**2*$v + 4020*$w**3*$v - 980*$w**4*$v + $x2y2*(-6440*$w + 1750*$w**2 - 1512*$w**2*$v));
}

sub gameformula {
  my ($x, $z) = @_;
  $x**3*(20*$z + 15*$x - 60*$x*$z + $x**2*(-24 + 10*$x + 60*$z - 20*$x*$z));
#  $x**2*(9*$x**2 - 12*$x**3 + 4*$x**4 + $z*(6 - 4*$x - 18*$x**2 + 24*$x**3 - 8*$x**4));
}

sub matchformula {
  my ($decider, $x, $z) = @_;
  if ($decider == 1) {
    return $x**2 + 2*$x*(1 - $x)*$z;
  } else {
    return $x**2*(4*$x - 3*$x**2 + 6*$z*(1-$x)**2);
  }
}

sub notiebreakP {
  my ($x, $y) = @_;
  $x*(1 - $y)/($x + $y - 2*$x*$y)
}

sub deuceP {
  my $p = shift;
  $p**2/(1 - 2*$p*(1 - $p))
}

1;
